positivesComp :: [Int] -> [Int]
positivesComp xs  =  [ x | x <- xs, x > 0 ]

positivesRec :: [Int] -> [Int]
positivesRec []                  =  []
positivesRec (x:xs) | x > 0      =  x : positivesRec xs
                    | otherwise  =  positivesRec xs

positivesFilter :: [Int] -> [Int]
positivesFilter xs  =  filter pos xs
  where
  pos x  =  x > 0

prop_positives :: [Int] -> Bool
prop_positives xs  =  positivesComp xs == positivesRec xs && positivesRec xs == positivesFilter xs
